Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 455394 - ucarp does not allow netmasks other than /32
Summary: ucarp does not allow netmasks other than /32
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: ucarp
Version: 9
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Gwyn Ciesla
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-07-15 11:44 UTC by Benny Amorsen
Modified: 2016-05-03 13:00 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-07-14 18:10:23 UTC


Attachments (Terms of Use)
Patch to accept IP-addresses with masklen. (deleted)
2009-04-16 09:25 UTC, Benny Amorsen
no flags Details

Description Benny Amorsen 2008-07-15 11:44:04 UTC
Description of problem:
With previous init scripts (from 1.2) it was possible to easily override the
standard up script, which made these things possible:

*) Non-/32 netmask
*) Multiple IP addresses per ucarp daemon

The downside of overriding the standard scripts was that:

*) Gratuituous ARP was done to 255.255.255.255 (which was useless)
*) ucarp is unaware of the addresses, so it cannot do gratuituous ARP for them.

This could be mitigated by doing gratuituous ARP in the script.

There is one more problem with both the old and the new scripts. The VHID
depends on the name of the configuration file. This is a problem for routers,
where it is useful to keep the same VHID on all interfaces (obviously it is not
correct to have the same VHID twice on the same interface).

Version-Release number of selected component (if applicable):
ucarp-1.4-1.fc9.i386

Ah, I just figured out that it is possible to add UPSCRIPT= to the configuration
file. It would be nice if that was documented.

Comment 1 Christopher D. Stover 2008-10-27 02:40:21 UTC
This bug has been triaged

Comment 2 Fedora Admin XMLRPC Client 2009-04-13 12:23:29 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 3 Fedora Update System 2009-04-13 14:47:16 UTC
ucarp-1.5-1.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/ucarp-1.5-1.fc10

Comment 4 Fedora Update System 2009-04-13 14:47:33 UTC
ucarp-1.5-1.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/ucarp-1.5-1.fc9

Comment 5 Fedora Update System 2009-04-14 15:53:43 UTC
ucarp-1.5-1.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update ucarp'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-3643

Comment 6 Fedora Update System 2009-04-14 15:54:18 UTC
ucarp-1.5-1.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing-newkey update ucarp'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2009-3648

Comment 7 Benny Amorsen 2009-04-15 19:28:17 UTC
The UPSCRIPT option is gone, as far as I can tell. You can still use OPTIONS= to specify different files though, but it's not particularly smooth.

The default scripts still cannot handle netmasks other than /32.

Comment 8 Gwyn Ciesla 2009-04-15 19:36:51 UTC
Is there a modification to the default scripts that could be made both to allow other netmasks, and not break existing behaviour?

Comment 9 Benny Amorsen 2009-04-16 09:24:33 UTC
Unfortunately staying compatible with existing behaviour probably requires modifications to ucarp. ucarp would need to accept 10.10.10.10/27 as a valid IP address but ignore the /27 except for passing to existing scripts. I have attached a proposed patch. Compile tested only; I have a similar patch in production which adds /32 if no netmask is passed, but that won't be compatible with existing scripts. The attached patch should be compatible with existing scripts, as long as the user does not use the new netmask functionality.

Comment 10 Benny Amorsen 2009-04-16 09:25:44 UTC
Created attachment 339817 [details]
Patch to accept IP-addresses with masklen.

Comment 11 Gwyn Ciesla 2009-04-17 13:45:06 UTC
This looks like the sort of thing that might be better done upstream.  I'll contact the author and get his $0.02.

Comment 12 Bug Zapper 2009-06-10 02:05:30 UTC
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 13 Bug Zapper 2009-07-14 18:10:23 UTC
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 14 Robert Scheck 2016-05-02 16:23:25 UTC
Jon, did you ever hear from upstream? The patch is what I would need here...

Comment 15 Gwyn Ciesla 2016-05-03 13:00:11 UTC
I didn't. I would be willing to try this patch out, if it can be extensively tested.  I'd be willing to post builds for specified releases architectures.


Note You need to log in before you can comment on or make changes to this bug.